"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import messages.common_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class Ping(google.protobuf.message.Message):
    """
    Ping message is sent from the server (cloud) to the client (robot) to test connectivity.
    The robot will respond with a Pong message.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUEST_ID_FIELD_NUMBER: builtins.int
    TIMESTAMP_FIELD_NUMBER: builtins.int
    request_id: builtins.str
    """/ Request Id generated by the caller"""
    timestamp: builtins.int
    """/ Timestamp of the ping request in milliseconds UNIX epoch"""
    def __init__(
        self,
        *,
        request_id: builtins.str = ...,
        timestamp: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["request_id", b"request_id", "timestamp", b"timestamp"]) -> None: ...

global___Ping = Ping

@typing_extensions.final
class ConnectivityStatus(google.protobuf.message.Message):
    """
    ConnectivityStatus is sent in a Pong message a response to a Ping message sent by the
    server. It is used to evaluate the connectivity of the robot to the cloud.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUEST_ID_FIELD_NUMBER: builtins.int
    PING_SENT_AT_FIELD_NUMBER: builtins.int
    request_id: builtins.str
    """/ Request Id generated by the caller"""
    ping_sent_at: builtins.int
    """/ Timestamp of the corresponding ping request in milliseconds UNIX epoch"""
    def __init__(
        self,
        *,
        request_id: builtins.str = ...,
        ping_sent_at: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["ping_sent_at", b"ping_sent_at", "request_id", b"request_id"]) -> None: ...

global___ConnectivityStatus = ConnectivityStatus

@typing_extensions.final
class Pong(google.protobuf.message.Message):
    """
    A Pong message is sent from the client (robot) to the server (cloud) as a response to a Ping message
    sent by the server. The ConnectivityStatus message includes the Ping message request id and timestamp
    that the ping message was sent and is used to calculate round-trip latency.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONNECT_FIELD_NUMBER: builtins.int
    CONNECTIVITY_STATUS_FIELD_NUMBER: builtins.int
    @property
    def connect(self) -> messages.common_pb2.Connect:
        """/ Initial request to set up a bidi stream"""
    @property
    def connectivity_status(self) -> global___ConnectivityStatus:
        """/ The robot will acknowledge a control request"""
    def __init__(
        self,
        *,
        connect: messages.common_pb2.Connect | None = ...,
        connectivity_status: global___ConnectivityStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["connect", b"connect", "connectivity_status", b"connectivity_status", "message", b"message"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["connect", b"connect", "connectivity_status", b"connectivity_status", "message", b"message"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["message", b"message"]) -> typing_extensions.Literal["connect", "connectivity_status"] | None: ...

global___Pong = Pong

@typing_extensions.final
class RobotConnectionStatus(google.protobuf.message.Message):
    """
    Connection Status robot <-> cloud
    The last robot connection status is stored in the cloud and exposed to the frontend.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROBOT_DATA_SET_ID_FIELD_NUMBER: builtins.int
    LATENCY_FIELD_NUMBER: builtins.int
    LAST_RECEIVED_PONG_FIELD_NUMBER: builtins.int
    HEARTBEAT_FIELD_NUMBER: builtins.int
    robot_data_set_id: builtins.int
    """/ Robot data set id"""
    latency: builtins.int
    """/ Robot connection latency in milliseconds"""
    last_received_pong: builtins.int
    """/ Timestamp of last received pong answer from robot as Datetime UTC"""
    heartbeat: builtins.int
    """/ Heartbeat message count (monotonically increasing)"""
    def __init__(
        self,
        *,
        robot_data_set_id: builtins.int = ...,
        latency: builtins.int = ...,
        last_received_pong: builtins.int = ...,
        heartbeat: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["heartbeat", b"heartbeat", "last_received_pong", b"last_received_pong", "latency", b"latency", "robot_data_set_id", b"robot_data_set_id"]) -> None: ...

global___RobotConnectionStatus = RobotConnectionStatus

@typing_extensions.final
class RobotConnectionResponse(google.protobuf.message.Message):
    """/ A bundling of all currently connected and active robots"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROBOTS_FIELD_NUMBER: builtins.int
    @property
    def robots(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___RobotConnectionStatus]:
        """/ List of all robots"""
    def __init__(
        self,
        *,
        robots: collections.abc.Iterable[global___RobotConnectionStatus] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["robots", b"robots"]) -> None: ...

global___RobotConnectionResponse = RobotConnectionResponse

@typing_extensions.final
class RobotConnectionRequest(google.protobuf.message.Message):
    """/ Request issued by InRobot to start listening in on connected robots"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STREAM_INTERVAL_FIELD_NUMBER: builtins.int
    stream_interval: builtins.int
    """/ Specify the interval in millis in which you want to receive heartbeats"""
    def __init__(
        self,
        *,
        stream_interval: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["stream_interval", b"stream_interval"]) -> None: ...

global___RobotConnectionRequest = RobotConnectionRequest
