"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import messages.geometry_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class Waypoint(google.protobuf.message.Message):
    """/ Waypoint defines a position and orientation in the map"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    POSITION_FIELD_NUMBER: builtins.int
    ORIENTATION_FIELD_NUMBER: builtins.int
    id: builtins.str
    """/ Waypoint with position given in the Map frame of currently active map"""
    @property
    def position(self) -> messages.geometry_pb2.Point:
        """/ 3D position in meters"""
    @property
    def orientation(self) -> messages.geometry_pb2.Quaternion:
        """/ SO(3) rotation represented in quaternions"""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        position: messages.geometry_pb2.Point | None = ...,
        orientation: messages.geometry_pb2.Quaternion | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["orientation", b"orientation", "position", b"position"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id", "orientation", b"orientation", "position", b"position"]) -> None: ...

global___Waypoint = Waypoint

@typing_extensions.final
class RobotCapability(google.protobuf.message.Message):
    """/ Robot integration defines what acpabilities it supports"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CAPABILITY_EXTERNAL_ID_FIELD_NUMBER: builtins.int
    capability_external_id: builtins.str
    """/ ID of the capability as registered in robotics services"""
    def __init__(
        self,
        *,
        capability_external_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["capability_external_id", b"capability_external_id"]) -> None: ...

global___RobotCapability = RobotCapability

@typing_extensions.final
class Action(google.protobuf.message.Message):
    """/ Action defines what the robot should do at a waypoint"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACTION_REPORT_ID_FIELD_NUMBER: builtins.int
    WAYPOINT_FIELD_NUMBER: builtins.int
    CAPABILITY_FIELD_NUMBER: builtins.int
    CAPABILITY_INPUT_FIELD_NUMBER: builtins.int
    DATA_HANDLING_INPUT_FIELD_NUMBER: builtins.int
    DATA_POSTPROCESSING_INPUT_FIELD_NUMBER: builtins.int
    ASSET_IDS_FIELD_NUMBER: builtins.int
    action_report_id: builtins.str
    """/ Report id of the action. This is used to report back the status of the action"""
    @property
    def waypoint(self) -> global___Waypoint:
        """/ Waypoint at which the action is executed"""
    @property
    def capability(self) -> global___RobotCapability:
        """/ Robot capability required to execute the action"""
    capability_input: builtins.str
    """/ JSON object validated against input_schema of capability"""
    data_handling_input: builtins.str
    """/ Data handling instructions (including upload instructions). JSON object string"""
    data_postprocessing_input: builtins.str
    """/ Postprocessing instructions for the data once uploaded. JSON object string"""
    @property
    def asset_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]:
        """/ Asset ids where the action is executed. Currently only one asset per action is supported."""
    def __init__(
        self,
        *,
        action_report_id: builtins.str = ...,
        waypoint: global___Waypoint | None = ...,
        capability: global___RobotCapability | None = ...,
        capability_input: builtins.str = ...,
        data_handling_input: builtins.str = ...,
        data_postprocessing_input: builtins.str = ...,
        asset_ids: collections.abc.Iterable[builtins.int] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["capability", b"capability", "waypoint", b"waypoint"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["action_report_id", b"action_report_id", "asset_ids", b"asset_ids", "capability", b"capability", "capability_input", b"capability_input", "data_handling_input", b"data_handling_input", "data_postprocessing_input", b"data_postprocessing_input", "waypoint", b"waypoint"]) -> None: ...

global___Action = Action

@typing_extensions.final
class Mission(google.protobuf.message.Message):
    """/ Robot mission definition, which is a sequence of actions"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MISSION_EXTERNAL_ID_FIELD_NUMBER: builtins.int
    MISSION_REPORT_ID_FIELD_NUMBER: builtins.int
    ACTIONS_FIELD_NUMBER: builtins.int
    mission_external_id: builtins.str
    """/ A mission can either be a Cognite Robotics mission, which has all inputs (Action) specified, or an external mission (e.g., from a robot vendor)."""
    mission_report_id: builtins.str
    """/ CDF/FDM specific mission report id"""
    @property
    def actions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Action]:
        """/ The order of actions here represents order of execution."""
    def __init__(
        self,
        *,
        mission_external_id: builtins.str = ...,
        mission_report_id: builtins.str = ...,
        actions: collections.abc.Iterable[global___Action] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["actions", b"actions", "mission_external_id", b"mission_external_id", "mission_report_id", b"mission_report_id"]) -> None: ...

global___Mission = Mission
